Index: code/trunk/data/gui/schemes/OrxonoxHUDWidgets.scheme
===================================================================
--- code/trunk/data/gui/schemes/OrxonoxHUDWidgets.scheme	(revision 7801)
+++ code/trunk/data/gui/schemes/OrxonoxHUDWidgets.scheme	(revision 7801)
@@ -0,0 +1,42 @@
+<?xml version="1.0" ?>
+<GUIScheme Name="OrxonoxHUDWidgets">
+    <WindowAlias Alias="HUDWidgets/StaticImage"              Target="OrxonoxLook/StaticImage" />
+    <WindowAlias Alias="HUDWidgets/StaticText"               Target="OrxonoxLook/StaticText" />
+    <WindowAlias Alias="HUDWidgets/TabButtonPane"            Target="OrxonoxLook/TabButtonPane" />
+    <WindowAlias Alias="HUDWidgets/TabContentPane"           Target="OrxonoxLook/TabContentPane" />
+    <WindowAlias Alias="HUDWidgets/Checkbox"                 Target="OrxonoxLook/Checkbox" />
+    <WindowAlias Alias="HUDWidgets/Combobox"                 Target="OrxonoxLook/Combobox" />
+    <WindowAlias Alias="HUDWidgets/ComboDropList"            Target="OrxonoxLook/ComboDropList" />
+    <WindowAlias Alias="HUDWidgets/ComboEditbox"             Target="OrxonoxLook/ComboEditbox" />
+    <WindowAlias Alias="HUDWidgets/Editbox"                  Target="OrxonoxLook/Editbox" />
+    <WindowAlias Alias="HUDWidgets/FrameWindow"              Target="OrxonoxLook/FrameWindow" />
+    <WindowAlias Alias="HUDWidgets/GroupBox"                 Target="OrxonoxLook/GroupBox" />
+    <WindowAlias Alias="HUDWidgets/ItemListbox"              Target="OrxonoxLook/ItemListbox" />
+    <WindowAlias Alias="HUDWidgets/ListboxItem"              Target="OrxonoxLook/ListboxItem" />
+    <WindowAlias Alias="HUDWidgets/Listbox"                  Target="OrxonoxLook/Listbox" />
+    <WindowAlias Alias="HUDWidgets/ListHeader"               Target="OrxonoxLook/ListHeader" />
+    <WindowAlias Alias="HUDWidgets/ListHeaderSegment"        Target="OrxonoxLook/ListHeaderSegment" />
+    <WindowAlias Alias="HUDWidgets/MultiLineEditbox"         Target="OrxonoxLook/MultiLineEditbox" />
+    <WindowAlias Alias="HUDWidgets/Menubar"                  Target="OrxonoxLook/Menubar" />
+    <WindowAlias Alias="HUDWidgets/MenuItem"                 Target="OrxonoxLook/MenuItem" />
+    <WindowAlias Alias="HUDWidgets/MultiColumnList"          Target="OrxonoxLook/MultiColumnList" />
+    <WindowAlias Alias="HUDWidgets/PopupMenu"                Target="OrxonoxLook/PopupMenu" />
+    <WindowAlias Alias="HUDWidgets/ProgressBar"              Target="OrxonoxLook/ProgressBar" />
+    <WindowAlias Alias="HUDWidgets/Button"                   Target="OrxonoxLook/Button" />
+    <WindowAlias Alias="HUDWidgets/ImageButton"              Target="OrxonoxLook/ImageButton" />
+    <WindowAlias Alias="HUDWidgets/RadioButton"              Target="OrxonoxLook/RadioButton" />
+    <WindowAlias Alias="HUDWidgets/SystemButton"             Target="OrxonoxLook/SystemButton" />
+    <WindowAlias Alias="HUDWidgets/ScrollablePane"           Target="OrxonoxLook/ScrollablePane" />
+    <WindowAlias Alias="HUDWidgets/HorizontalScrollbar"      Target="OrxonoxLook/HorizontalScrollbar" />
+    <WindowAlias Alias="HUDWidgets/VerticalScrollbar"        Target="OrxonoxLook/VerticalScrollbar" />
+    <WindowAlias Alias="HUDWidgets/Slider"                   Target="OrxonoxLook/Slider" />
+    <WindowAlias Alias="HUDWidgets/Spinner"                  Target="OrxonoxLook/Spinner" />
+    <WindowAlias Alias="HUDWidgets/TabButton"                Target="OrxonoxLook/TabButton" />
+    <WindowAlias Alias="HUDWidgets/TabControl"               Target="OrxonoxLook/TabControl" />
+    <WindowAlias Alias="HUDWidgets/HorizontalScrollbarThumb" Target="OrxonoxLook/HorizontalScrollbarThumb" />
+    <WindowAlias Alias="HUDWidgets/SliderThumb"              Target="OrxonoxLook/SliderThumb" />
+    <WindowAlias Alias="HUDWidgets/VerticalScrollbarThumb"   Target="OrxonoxLook/VerticalScrollbarThumb" />
+    <WindowAlias Alias="HUDWidgets/Titlebar"                 Target="OrxonoxLook/Titlebar" />
+    <WindowAlias Alias="HUDWidgets/Tooltip"                  Target="OrxonoxLook/Tooltip" />
+    <WindowAlias Alias="HUDWidgets/Tree"                     Target="OrxonoxLook/Tree" />
+</GUIScheme>
Index: code/trunk/data/gui/schemes/OrxonoxLookHUDWidgets.scheme
===================================================================
--- code/trunk/data/gui/schemes/OrxonoxLookHUDWidgets.scheme	(revision 7734)
+++ 	(revision )
@@ -1,42 +1,0 @@
-<?xml version="1.0" ?>
-<GUIScheme Name="OrxonoxLookHUDWidgets">
-    <WindowAlias Alias="HUDWidgets/StaticImage"              Target="OrxonoxLook/StaticImage" />
-    <WindowAlias Alias="HUDWidgets/StaticText"               Target="OrxonoxLook/StaticText" />
-    <WindowAlias Alias="HUDWidgets/TabButtonPane"            Target="OrxonoxLook/TabButtonPane" />
-    <WindowAlias Alias="HUDWidgets/TabContentPane"           Target="OrxonoxLook/TabContentPane" />
-    <WindowAlias Alias="HUDWidgets/Checkbox"                 Target="OrxonoxLook/Checkbox" />
-    <WindowAlias Alias="HUDWidgets/Combobox"                 Target="OrxonoxLook/Combobox" />
-    <WindowAlias Alias="HUDWidgets/ComboDropList"            Target="OrxonoxLook/ComboDropList" />
-    <WindowAlias Alias="HUDWidgets/ComboEditbox"             Target="OrxonoxLook/ComboEditbox" />
-    <WindowAlias Alias="HUDWidgets/Editbox"                  Target="OrxonoxLook/Editbox" />
-    <WindowAlias Alias="HUDWidgets/FrameWindow"              Target="OrxonoxLook/FrameWindow" />
-    <WindowAlias Alias="HUDWidgets/GroupBox"                 Target="OrxonoxLook/GroupBox" />
-    <WindowAlias Alias="HUDWidgets/ItemListbox"              Target="OrxonoxLook/ItemListbox" />
-    <WindowAlias Alias="HUDWidgets/ListboxItem"              Target="OrxonoxLook/ListboxItem" />
-    <WindowAlias Alias="HUDWidgets/Listbox"                  Target="OrxonoxLook/Listbox" />
-    <WindowAlias Alias="HUDWidgets/ListHeader"               Target="OrxonoxLook/ListHeader" />
-    <WindowAlias Alias="HUDWidgets/ListHeaderSegment"        Target="OrxonoxLook/ListHeaderSegment" />
-    <WindowAlias Alias="HUDWidgets/MultiLineEditbox"         Target="OrxonoxLook/MultiLineEditbox" />
-    <WindowAlias Alias="HUDWidgets/Menubar"                  Target="OrxonoxLook/Menubar" />
-    <WindowAlias Alias="HUDWidgets/MenuItem"                 Target="OrxonoxLook/MenuItem" />
-    <WindowAlias Alias="HUDWidgets/MultiColumnList"          Target="OrxonoxLook/MultiColumnList" />
-    <WindowAlias Alias="HUDWidgets/PopupMenu"                Target="OrxonoxLook/PopupMenu" />
-    <WindowAlias Alias="HUDWidgets/ProgressBar"              Target="OrxonoxLook/ProgressBar" />
-    <WindowAlias Alias="HUDWidgets/Button"                   Target="OrxonoxLook/Button" />
-    <WindowAlias Alias="HUDWidgets/ImageButton"              Target="OrxonoxLook/ImageButton" />
-    <WindowAlias Alias="HUDWidgets/RadioButton"              Target="OrxonoxLook/RadioButton" />
-    <WindowAlias Alias="HUDWidgets/SystemButton"             Target="OrxonoxLook/SystemButton" />
-    <WindowAlias Alias="HUDWidgets/ScrollablePane"           Target="OrxonoxLook/ScrollablePane" />
-    <WindowAlias Alias="HUDWidgets/HorizontalScrollbar"      Target="OrxonoxLook/HorizontalScrollbar" />
-    <WindowAlias Alias="HUDWidgets/VerticalScrollbar"        Target="OrxonoxLook/VerticalScrollbar" />
-    <WindowAlias Alias="HUDWidgets/Slider"                   Target="OrxonoxLook/Slider" />
-    <WindowAlias Alias="HUDWidgets/Spinner"                  Target="OrxonoxLook/Spinner" />
-    <WindowAlias Alias="HUDWidgets/TabButton"                Target="OrxonoxLook/TabButton" />
-    <WindowAlias Alias="HUDWidgets/TabControl"               Target="OrxonoxLook/TabControl" />
-    <WindowAlias Alias="HUDWidgets/HorizontalScrollbarThumb" Target="OrxonoxLook/HorizontalScrollbarThumb" />
-    <WindowAlias Alias="HUDWidgets/SliderThumb"              Target="OrxonoxLook/SliderThumb" />
-    <WindowAlias Alias="HUDWidgets/VerticalScrollbarThumb"   Target="OrxonoxLook/VerticalScrollbarThumb" />
-    <WindowAlias Alias="HUDWidgets/Titlebar"                 Target="OrxonoxLook/Titlebar" />
-    <WindowAlias Alias="HUDWidgets/Tooltip"                  Target="OrxonoxLook/Tooltip" />
-    <WindowAlias Alias="HUDWidgets/Tree"                     Target="OrxonoxLook/Tree" />
-</GUIScheme>
Index: code/trunk/data/gui/schemes/OrxonoxLookMenuWidgets.scheme
===================================================================
--- code/trunk/data/gui/schemes/OrxonoxLookMenuWidgets.scheme	(revision 7734)
+++ 	(revision )
@@ -1,42 +1,0 @@
-<?xml version="1.0" ?>
-<GUIScheme Name="OrxonoxLookMenuWidgets">
-    <WindowAlias Alias="MenuWidgets/StaticImage"              Target="OrxonoxLook/StaticImage" />
-    <WindowAlias Alias="MenuWidgets/StaticText"               Target="OrxonoxLook/StaticText" />
-    <WindowAlias Alias="MenuWidgets/TabButtonPane"            Target="OrxonoxLook/TabButtonPane" />
-    <WindowAlias Alias="MenuWidgets/TabContentPane"           Target="OrxonoxLook/TabContentPane" />
-    <WindowAlias Alias="MenuWidgets/Checkbox"                 Target="OrxonoxLook/Checkbox" />
-    <WindowAlias Alias="MenuWidgets/Combobox"                 Target="OrxonoxLook/Combobox" />
-    <WindowAlias Alias="MenuWidgets/ComboDropList"            Target="OrxonoxLook/ComboDropList" />
-    <WindowAlias Alias="MenuWidgets/ComboEditbox"             Target="OrxonoxLook/ComboEditbox" />
-    <WindowAlias Alias="MenuWidgets/Editbox"                  Target="OrxonoxLook/Editbox" />
-    <WindowAlias Alias="MenuWidgets/FrameWindow"              Target="OrxonoxLook/FrameWindow" />
-    <WindowAlias Alias="MenuWidgets/GroupBox"                 Target="OrxonoxLook/GroupBox" />
-    <WindowAlias Alias="MenuWidgets/ItemListbox"              Target="OrxonoxLook/ItemListbox" />
-    <WindowAlias Alias="MenuWidgets/ListboxItem"              Target="OrxonoxLook/ListboxItem" />
-    <WindowAlias Alias="MenuWidgets/Listbox"                  Target="OrxonoxLook/Listbox" />
-    <WindowAlias Alias="MenuWidgets/ListHeader"               Target="OrxonoxLook/ListHeader" />
-    <WindowAlias Alias="MenuWidgets/ListHeaderSegment"        Target="OrxonoxLook/ListHeaderSegment" />
-    <WindowAlias Alias="MenuWidgets/MultiLineEditbox"         Target="OrxonoxLook/MultiLineEditbox" />
-    <WindowAlias Alias="MenuWidgets/Menubar"                  Target="OrxonoxLook/Menubar" />
-    <WindowAlias Alias="MenuWidgets/MenuItem"                 Target="OrxonoxLook/MenuItem" />
-    <WindowAlias Alias="MenuWidgets/MultiColumnList"          Target="OrxonoxLook/MultiColumnList" />
-    <WindowAlias Alias="MenuWidgets/PopupMenu"                Target="OrxonoxLook/PopupMenu" />
-    <WindowAlias Alias="MenuWidgets/ProgressBar"              Target="OrxonoxLook/ProgressBar" />
-    <WindowAlias Alias="MenuWidgets/Button"                   Target="OrxonoxLook/Button" />
-    <WindowAlias Alias="MenuWidgets/ImageButton"              Target="OrxonoxLook/ImageButton" />
-    <WindowAlias Alias="MenuWidgets/RadioButton"              Target="OrxonoxLook/RadioButton" />
-    <WindowAlias Alias="MenuWidgets/SystemButton"             Target="OrxonoxLook/SystemButton" />
-    <WindowAlias Alias="MenuWidgets/ScrollablePane"           Target="OrxonoxLook/ScrollablePane" />
-    <WindowAlias Alias="MenuWidgets/HorizontalScrollbar"      Target="OrxonoxLook/HorizontalScrollbar" />
-    <WindowAlias Alias="MenuWidgets/VerticalScrollbar"        Target="OrxonoxLook/VerticalScrollbar" />
-    <WindowAlias Alias="MenuWidgets/Slider"                   Target="OrxonoxLook/Slider" />
-    <WindowAlias Alias="MenuWidgets/Spinner"                  Target="OrxonoxLook/Spinner" />
-    <WindowAlias Alias="MenuWidgets/TabButton"                Target="OrxonoxLook/TabButton" />
-    <WindowAlias Alias="MenuWidgets/TabControl"               Target="OrxonoxLook/TabControl" />
-    <WindowAlias Alias="MenuWidgets/HorizontalScrollbarThumb" Target="OrxonoxLook/HorizontalScrollbarThumb" />
-    <WindowAlias Alias="MenuWidgets/SliderThumb"              Target="OrxonoxLook/SliderThumb" />
-    <WindowAlias Alias="MenuWidgets/VerticalScrollbarThumb"   Target="OrxonoxLook/VerticalScrollbarThumb" />
-    <WindowAlias Alias="MenuWidgets/Titlebar"                 Target="OrxonoxLook/Titlebar" />
-    <WindowAlias Alias="MenuWidgets/Tooltip"                  Target="OrxonoxLook/Tooltip" />
-    <WindowAlias Alias="MenuWidgets/Tree"                     Target="OrxonoxLook/Tree" />
-</GUIScheme>
Index: code/trunk/data/gui/schemes/OrxonoxMenuWidgets.scheme
===================================================================
--- code/trunk/data/gui/schemes/OrxonoxMenuWidgets.scheme	(revision 7801)
+++ code/trunk/data/gui/schemes/OrxonoxMenuWidgets.scheme	(revision 7801)
@@ -0,0 +1,42 @@
+<?xml version="1.0" ?>
+<GUIScheme Name="OrxonoxMenuWidgets">
+    <WindowAlias Alias="MenuWidgets/StaticImage"              Target="OrxonoxLook/StaticImage" />
+    <WindowAlias Alias="MenuWidgets/StaticText"               Target="OrxonoxLook/StaticText" />
+    <WindowAlias Alias="MenuWidgets/TabButtonPane"            Target="OrxonoxLook/TabButtonPane" />
+    <WindowAlias Alias="MenuWidgets/TabContentPane"           Target="OrxonoxLook/TabContentPane" />
+    <WindowAlias Alias="MenuWidgets/Checkbox"                 Target="OrxonoxLook/Checkbox" />
+    <WindowAlias Alias="MenuWidgets/Combobox"                 Target="OrxonoxLook/Combobox" />
+    <WindowAlias Alias="MenuWidgets/ComboDropList"            Target="OrxonoxLook/ComboDropList" />
+    <WindowAlias Alias="MenuWidgets/ComboEditbox"             Target="OrxonoxLook/ComboEditbox" />
+    <WindowAlias Alias="MenuWidgets/Editbox"                  Target="OrxonoxLook/Editbox" />
+    <WindowAlias Alias="MenuWidgets/FrameWindow"              Target="OrxonoxLook/FrameWindow" />
+    <WindowAlias Alias="MenuWidgets/GroupBox"                 Target="OrxonoxLook/GroupBox" />
+    <WindowAlias Alias="MenuWidgets/ItemListbox"              Target="OrxonoxLook/ItemListbox" />
+    <WindowAlias Alias="MenuWidgets/ListboxItem"              Target="OrxonoxLook/ListboxItem" />
+    <WindowAlias Alias="MenuWidgets/Listbox"                  Target="OrxonoxLook/Listbox" />
+    <WindowAlias Alias="MenuWidgets/ListHeader"               Target="OrxonoxLook/ListHeader" />
+    <WindowAlias Alias="MenuWidgets/ListHeaderSegment"        Target="OrxonoxLook/ListHeaderSegment" />
+    <WindowAlias Alias="MenuWidgets/MultiLineEditbox"         Target="OrxonoxLook/MultiLineEditbox" />
+    <WindowAlias Alias="MenuWidgets/Menubar"                  Target="OrxonoxLook/Menubar" />
+    <WindowAlias Alias="MenuWidgets/MenuItem"                 Target="OrxonoxLook/MenuItem" />
+    <WindowAlias Alias="MenuWidgets/MultiColumnList"          Target="OrxonoxLook/MultiColumnList" />
+    <WindowAlias Alias="MenuWidgets/PopupMenu"                Target="OrxonoxLook/PopupMenu" />
+    <WindowAlias Alias="MenuWidgets/ProgressBar"              Target="OrxonoxLook/ProgressBar" />
+    <WindowAlias Alias="MenuWidgets/Button"                   Target="OrxonoxLook/Button" />
+    <WindowAlias Alias="MenuWidgets/ImageButton"              Target="OrxonoxLook/ImageButton" />
+    <WindowAlias Alias="MenuWidgets/RadioButton"              Target="OrxonoxLook/RadioButton" />
+    <WindowAlias Alias="MenuWidgets/SystemButton"             Target="OrxonoxLook/SystemButton" />
+    <WindowAlias Alias="MenuWidgets/ScrollablePane"           Target="OrxonoxLook/ScrollablePane" />
+    <WindowAlias Alias="MenuWidgets/HorizontalScrollbar"      Target="OrxonoxLook/HorizontalScrollbar" />
+    <WindowAlias Alias="MenuWidgets/VerticalScrollbar"        Target="OrxonoxLook/VerticalScrollbar" />
+    <WindowAlias Alias="MenuWidgets/Slider"                   Target="OrxonoxLook/Slider" />
+    <WindowAlias Alias="MenuWidgets/Spinner"                  Target="OrxonoxLook/Spinner" />
+    <WindowAlias Alias="MenuWidgets/TabButton"                Target="OrxonoxLook/TabButton" />
+    <WindowAlias Alias="MenuWidgets/TabControl"               Target="OrxonoxLook/TabControl" />
+    <WindowAlias Alias="MenuWidgets/HorizontalScrollbarThumb" Target="OrxonoxLook/HorizontalScrollbarThumb" />
+    <WindowAlias Alias="MenuWidgets/SliderThumb"              Target="OrxonoxLook/SliderThumb" />
+    <WindowAlias Alias="MenuWidgets/VerticalScrollbarThumb"   Target="OrxonoxLook/VerticalScrollbarThumb" />
+    <WindowAlias Alias="MenuWidgets/Titlebar"                 Target="OrxonoxLook/Titlebar" />
+    <WindowAlias Alias="MenuWidgets/Tooltip"                  Target="OrxonoxLook/Tooltip" />
+    <WindowAlias Alias="MenuWidgets/Tree"                     Target="OrxonoxLook/Tree" />
+</GUIScheme>